import 'dart:async';
import 'dart:convert';
import 'dart:io';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutterbootpay/model/res/model/pay_result_data.dart';


import 'model/extra.dart';
import 'model/item.dart';
import 'model/payload.dart';
import 'model/user.dart';


typedef void VoidCallback();
typedef void StringCallback(String value);

class Flutterbootpay {
  static const MethodChannel _channel =
      const MethodChannel('flutterbootpay');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<PayResultData> Request(BuildContext context, Payload payload, {User user, List<Item> items, Extra extra,
    StringCallback onDone, StringCallback onReady, StringCallback onCancel, StringCallback onError}) async {
    payload.application_id = Platform.isAndroid ? payload.android_application_id : payload.ios_application_id;

    Map<String, dynamic> params = {
      "payload": payload.toJson(),
      if(user != null) "user" : user.toJson(),
      if(items != null) "items" : items,
      if(items != null) "items" : items.map((v) => v.toJson()).toList(),
      if(extra != null) "extra" : extra.toJson()
    };


    Map<dynamic, dynamic> result = await _channel.invokeMethod(
      "bootpayRequest",
      params,
    );


    String method = result["method"];
    String message = result["message"];

    if(method == "onDone") {
      if(onDone != null) onDone(message);
    } else if(method == "onReady") {
      if(onReady != null) onReady(message);
    } else if(method == "onCancel") {
      if(onCancel != null) onCancel(message);
    } else if(method == "onError") {
      if(onError != null) onError(message);
    }  //confirm 생략
  }
}
