

class Extra {
  String start_at = '';
  String end_at = '';
  int expire_month = 0;
  bool vbank_result = false;
  List<int> quotas;

  String app_scheme = '';
  String app_scheme_host = '';

  String locale = 'ko';

  int popup = 0;
  String disp_cash_result = 'Y';
  int escrow = 0;


  Extra(){}

  Extra.fromJson(Map<String, dynamic> json) {
    start_at = json["start_at"];
    end_at = json["end_at"];
    expire_month = json["expire_month"];
    vbank_result = json["vbank_result"];
    quotas = json["quotas"];

    app_scheme = json["app_scheme"];
    app_scheme_host = json["app_scheme_host"];

    locale = json["locale"];

    popup = json["popup"];
    disp_cash_result = json["disp_cash_result"];
    escrow = json["escrow"];

//    onestore = json["onestore"];
  }

  Map<String, dynamic> toJson() =>
      {
        "start_at": this.start_at,
        "end_at": this.end_at,
        "expire_month": this.expire_month,
        "vbank_result": this.vbank_result,
        "quotas": this.quotas,

        "app_scheme": this.app_scheme,
        "app_scheme_host": this.app_scheme_host,
        "locale": this.locale,

        "popup": this.popup,
        "disp_cash_result": this.disp_cash_result,
        "escrow": this.escrow,
      };

  String getQuotas() {
    if(quotas == null || quotas.isEmpty) return '';
    String result = '';
    for(int quota in quotas) {
      if(result.length > 0) result += ',';
      result += quota.toString();
    }
    return result;
  }


  String toString() {
    return "{start_at: '${reVal(start_at)}', end_at: '${reVal(end_at)}', expire_month: ${reVal(expire_month)}, vbank_result: ${reVal(vbank_result)},"
        + "quotas: '${getQuotas()}', app_scheme: '${reVal(app_scheme)}', app_scheme_host: '${reVal(app_scheme_host)}', locale: '${reVal(locale)}',"
        + "popup: ${reVal(popup)}, disp_cash_result: '${reVal(disp_cash_result)}', escrow: ${reVal(escrow)}}";
  }

  String reVal(dynamic value) {
    if(value is String) {
      if(value.isEmpty) { return ''; }
      return value.replaceAll("\"", "'").replaceAll("'", "\\'") ?? '';
    } else {
      return value.toString() ?? 0;
    }
  }
}
