import 'dart:async';
import 'dart:io';

import 'package:flutter/services.dart';

class Payload {
  String android_application_id = '';
  String ios_application_id = '';

  String application_id = '';
//  String rest_application_id; //해당 기능은 이해를 돕기위해 제공할 뿐, flutter에서 절대로 사용해서는 안됩니다

  String pg = '';
  String method = '';
  List<String> methods;
  String name = '';

  double price = 0;
  double tax_free = 0;

  String order_id = '';
  bool use_order_id = false;

  Map<String, dynamic> params;

  String account_expire_at = '';
  bool show_agree_window = false;

  String boot_key = '';
  String ux = 'PG_DIALOG';
  int sms_use = 0;
  String user_token = '';

  Payload(){
    this.methods = new List();
    this.params = new Map();
  }

  Payload.fromJson(Map<String, dynamic> json) {
    android_application_id = json["android_application_id"];
    ios_application_id = json["ios_application_id"];
//    rest_application_id = json["rest_application_id"];

    pg = json["pg"];
    method = json["method"];
    methods = json["methods"];
    name = json["name"];

    price = json["price"];
    tax_free = json["tax_free"];

    order_id = json["order_id"];
    use_order_id = json["use_order_id"];

    params = json["params"];

    account_expire_at = json["account_expire_at"];
    show_agree_window = json["show_agree_window"];

    boot_key = json["boot_key"];
    ux = json["ux"];
    sms_use = json["sms_use"];
    user_token = json["user_token"];
  }

  Map<String, dynamic> toJson() =>
      {
        "application_id": this.application_id,
        "pg": this.pg,
        "method": this.method,
        "methods": this.methods,
        "name": this.name,
        "price": this.price,
        "tax_free": this.tax_free,
        "order_id": this.order_id,
        "use_order_id": this.use_order_id,
        "params": Platform.isAndroid == true ? this.params.toString() : this.params,
        "account_expire_at": this.account_expire_at,
        "show_agree_window": this.show_agree_window,
        "ux": this.ux,
        "user_token": this.user_token,
      };

//  params: ${getParamsString()}, account_expire_at: '${account_expire_at}', show_agree_window: $show_agree_window, ux: '${ux}', sms_use: ${sms_use}, user_token: '${user_token}'";

  String toString() {
    return "{application_id: '${application_id}', pg: '${pg}', method: '${method}', name: '${name}', price: $price, tax_free: $tax_free, order_id: '${order_id}', use_order_id: $use_order_id, params: ${getParamsString()}, account_expire_at: '${account_expire_at}', show_agree_window: $show_agree_window, ux: '${ux}', sms_use: ${sms_use}, user_token: '${user_token}'";
  }

  String getParamsString() {
    if(params == null) return "{}";
    return reVal(params.toString());
  }

  String reVal(dynamic value) {

    if(value is String) {
      if(value.isEmpty) { return ''; }
      return value.replaceAll("\"", "'").replaceAll("'", "\\'");
    } else {
      return value;
    }
  }

  String getMethods() {
    if(methods == null || methods.isEmpty) return '';
    String result = '';
    for(String method in methods) {
      if(result.length > 0) result += ',';
      result += method;
    }
    return result;
  }
}
